; Fast square root routine
; by Frank Y. 10/25/03
; http://pyrosoft.distanthost.com
sqroot:				; sqrt d7, result in d5, destroy d4-d7
	move.l	d7,d5		; d5=(d5+d7/d5)/2
	lsr.l	#1,d5		; d5 starts as d7/2
\sqloop:
	move.l	d5,d4		; d4=last result
	move.l	d7,d6		; d6=d7
	divu.l	d5,d6		; d6=int(d6/d5)
	add.l	d6,d5		; d5=d6+d5
	lsr.l	#1,d5		; d5=d5/2
	cmp	d5,d4		; if last!=this
	bne	\sqloop		; then reiterate
	rts			; return